@echo off
if "%1"=="all" goto java
if "%1"=="java" goto java
if "%1"=="rmi" goto rmi
if "%1"=="win32" goto win32
if "%1"=="clean" goto clean
echo Usage:
echo make java    to rebuild Java classes
echo make rmi     to rebuild RMI stubs
echo make win32   to rebuild Win32 DLLs and EXEs
echo make all     to rebuild all of the above
goto end

:java
setlocal
set CLASSPATH=src;lib\pebbles.jar;%CLASSPATH%
javac -g src/*.java src/rcm/awt/*.java src/rcm/io/*.java src/rcm/progress/*.java src/rcm/util/*.java src/rcm/win32/*.java
endlocal
if "%1"=="java" goto end

:rmi
setlocal
set CLASSPATH=src;lib/pebbles.jar;%CLASSPATH%
rmic -v1.1 -d src RMIClipboardImpl
endlocal
if "%1"=="rmi" goto end

:win32
setlocal

cd src\rcm\win32
call make.bat ..\..\trayicon.rc
move TrayIcon.dll ..\..\..\lib
cd ..\..\..

cl "/I%JAVA_HOME%\include" "/I%JAVA_HOME%\include\win32" src\WindowsClipboard.c /link /dll /out:lib\WindowsClipboard.dll user32.lib gdi32.lib kernel32.lib shell32.lib

rc /fo rclip.res src\rclip.rc

set WRAPPER_CLASSPATH=\"*DIR*../src\",\"*DIR*../lib/*.jar\"
set WRAPPER_PATH=\"*DIR*../lib\"

cl /O1 src\wrapper.c /DCLASSPATH=%WRAPPER_CLASSPATH% /DPATH=%WRAPPER_PATH% /DJAVA_ARGS=\"RemoteClip\",\"-class\",\"WindowsClipboard\" /link /subsystem:windows rclip.res user32.lib /out:bin\rclip.exe

cl /O1 src\wrapper.c /DDEBUG /DCLASSPATH=%WRAPPER_CLASSPATH% /DPATH=%WRAPPER_PATH% /DJAVA_ARGS=\"RemoteClip\",\"-debug\",\"-class\",\"WindowsClipboard\" /DCONSOLE  /link /subsystem:console /out:bin\rclip-debug.exe

cl /O1 src\wrapper.c /DCLASSPATH=%WRAPPER_CLASSPATH% /DPATH=%WRAPPER_PATH% /DJAVA_ARGS=\"RemoteCopy\" /DCONSOLE  /link /subsystem:console /out:bin\rcopy.exe

cl /O1 src\wrapper.c /DCLASSPATH=%WRAPPER_CLASSPATH% /DPATH=%WRAPPER_PATH% /DJAVA_ARGS=\"RemotePaste\" /DCONSOLE  /link /subsystem:console /out:bin\rpaste.exe

endlocal
goto end

:clean
cd src
del /s *.class
cd ..
goto end

:end
